//----------------------------------------------------------------------//
//HotQ																	//
//	Nbv{[h													//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <algorithm>
#include <RegularExpressions.hpp>
#include "UIniFile.h"
#include "UserFunc.h"
#include "Unit1.h"
#include "ClipList.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TClipBdList *ClipBdList = NULL;

//---------------------------------------------------------------------------
//f[^
//---------------------------------------------------------------------------
HistoryRec::HistoryRec(UnicodeString s)
{
	CreTime  = Now();

	Text = s;
	LineCount = count_lins(s);

	if (s.Length()>128) s = s.SubString(1,128) + "...";
	s = ReplaceStr(s,"\r\n", "\n");
	s = ReplaceStr(s,"\r", "\n");
	ItemStr = s;
}

//---------------------------------------------------------------------------
// \[g֐(eLXg)
//---------------------------------------------------------------------------
int __fastcall HistCmp_Text(void * Item1, void * Item2)
{
	HistoryRec *hp1 = (HistoryRec *)Item1;
	HistoryRec *hp2 = (HistoryRec *)Item2;
	return CompareText(hp1->Text, hp2->Text);
}
//---------------------------------------------------------------------------
// \[g֐(ԏ)
//---------------------------------------------------------------------------
int __fastcall HistCmp_Time(void * Item1, void * Item2)
{
	HistoryRec *hp1 = (HistoryRec *)Item1;
	HistoryRec *hp2 = (HistoryRec *)Item2;
	if (hp1->CreTime == hp2->CreTime)
		return CompareText(hp1->Text, hp2->Text);
	else if (hp1->CreTime < hp2->CreTime)
		return 1;
	else
		return -1;
}
//---------------------------------------------------------------------------
// \[g֐(TCY)
//---------------------------------------------------------------------------
int __fastcall HistCmp_Length(void * Item1, void * Item2)
{
	HistoryRec *hp1 = (HistoryRec *)Item1;
	HistoryRec *hp2 = (HistoryRec *)Item2;
	if (hp1->Text.Length() == hp2->Text.Length())
		return HistCmp_Text(Item1, Item2);
	else
		return (hp2->Text.Length() - hp1->Text.Length());
}
//---------------------------------------------------------------------------
// \[g֐(s)
//---------------------------------------------------------------------------
int __fastcall HistCmp_LineCnt(void * Item1, void * Item2)
{
	HistoryRec *hp1 = (HistoryRec *)Item1;
	HistoryRec *hp2 = (HistoryRec *)Item2;
	if (hp1->LineCount == hp2->LineCount)
		return HistCmp_Length(Item1, Item2);
	else
		return (hp2->LineCount - hp1->LineCount);
}

//---------------------------------------------------------------------------
//f[^Xg (TList p)
//---------------------------------------------------------------------------
__fastcall THistoryList::THistoryList(): TList()
{
}
//---------------------------------------------------------------------------
__fastcall THistoryList::~THistoryList()
{
	for (int i=0; i<Count; i++) delete Items[i];
}

//---------------------------------------------------------------------------
HistoryRec * __fastcall THistoryList::Get(int Index)
{
	return (HistoryRec *)(TList::Get(Index));
}
//---------------------------------------------------------------------------
void __fastcall THistoryList::Put(int Index, HistoryRec *Item)
{
	TList::Put(Index, Item);
}

//---------------------------------------------------------------------------
//t@Cɕۑ
//---------------------------------------------------------------------------
void __fastcall THistoryList::SaveToFile(UnicodeString fname)
{
	if (fname.IsEmpty()) return;

	std::unique_ptr<TStringList> fbuf(new TStringList());
	for (int i=0; i<Count; i++) {
		HistoryRec *hp = Items[i];
		fbuf->Add("CreTime=" + hp->CreTime.DateTimeString());
		fbuf->Add("LineCount=" + IntToStr(hp->LineCount));
		fbuf->Add(hp->Text);
		fbuf->Add(EmptyStr);
	}
	fbuf->SaveToFile(fname, TEncoding::UTF8);
}
//---------------------------------------------------------------------------
//t@CǍ
//---------------------------------------------------------------------------
void __fastcall THistoryList::LoadFromFile(UnicodeString fname)
{
	if (!FileExists(fname)) return;

	for (int i=0; i<Count; i++) delete Items[i];
	Clear();

	std::unique_ptr<TStringList> tbuf(new TStringList());
	std::unique_ptr<TStringList> fbuf(new TStringList());
	fbuf->LoadFromFile(fname);

	int l_count;
	TDateTime c_time;
	int lp	= 0;
	int stt = 0;

	for (int i=0; i<fbuf->Count; i++) {
		UnicodeString lbuf = fbuf->Strings[i];
		switch (stt) {
		case 0:
			if (StartsText("CreTime=", lbuf)) {
				c_time = TDateTime(get_tkn_r(lbuf, "="));
				stt++;
			}
			break;
		case 1:
			if (StartsText("LineCount=", lbuf)) {
				l_count = get_tkn_r(lbuf, "=").ToIntDef(0);
				if (l_count>0) {
					tbuf->Clear();
					lp = 0;
					stt++;
				}
				else stt = 0;	//sȏ
			}
			else stt = 0;		//sȏ
			break;
		case 2:
			tbuf->Add(lbuf);
			if (++lp == l_count) {
				HistoryRec *hp = new HistoryRec(tbuf->Text);
				hp->CreTime   = c_time;
				hp->LineCount = l_count;
				Add(hp);
				stt = 0;
			}
			break;
		}
	}
}

//---------------------------------------------------------------------------
//`()ݒ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RecyclePrc()
{
	Screen->Cursor = crHourGlass;
	Hide();

	UnicodeString sct = "ClipboardList";

	if (ClipLstFont) delete ClipLstFont;
	ClipLstFont = IniFile->ReadFontInf(sct, Font);
	if (ClipLstFont) {
		HistListBox->Font->Assign(ClipLstFont);
		TextListBox->Font->Assign(ClipLstFont);
		PreviewMemo->Font->Assign(ClipLstFont);
		PreviewMemo->Font->Size = IniFile->ReadInteger(sct,"FontSizeV", ClipLstFont->Size);
	}

	ClipDataFile = IniFile->ReadString(sct, "ClipDataFile", "CLIPDATA.txt");
	get_file_name_r(ClipDataFile);
	TextDataFile = IniFile->ReadString(sct, "TextDataFile", "TEXTDATA.txt");
	get_file_name_r(TextDataFile);

	SaveHistory  = IniFile->ReadBool(  sct, "SaveHistory");

	MaxCbItems	 = IniFile->ReadInteger(sct, "MaxItems", 	50);
	MaxTextLen	 = IniFile->ReadInteger(sct, "MaxTextLen",	0);
	MaxLineCnt	 = IniFile->ReadInteger(sct, "MaxLineCnt",	0);
	ShowLnCt	 = IniFile->ReadBool(   sct, "ShowLnCt");
	PreviewLn	 = IniFile->ReadInteger(sct, "PreviewLn",	0);

	int ta = IniFile->ReadInteger(sct,"Transparent", 255);
	if (ta>=0 && ta<255) {
		//
		AlphaBlend		= true;
		AlphaBlendValue = ta;
	}
	else
		AlphaBlend		= false;

	ClipHistList = new THistoryList();
	if (SaveHistory) ClipHistList->LoadFromFile(ClipDataFile);

	if (!FileExists(TextDataFile))
		SaveTextList();
	else
		TextListBox->Items->LoadFromFile(TextDataFile);

	//^t@CI{^
	int bcnt = 0;
	for (int i=0; i<MAX_TEXTDATABTN; i++) {
		UnicodeString fnam = IniFile->ReadString(sct, "TextDataBtn"+IntToStr(i+1));
		if (!fnam.IsEmpty()) {
			get_file_name_r(fnam);
			bcnt++;
		}
		TextBtnFile[i] = fnam;
	}
	TextDataBtn1->Enabled = FileExists(TextBtnFile[0]);
	TextDataBtn2->Enabled = FileExists(TextBtnFile[1]);
	TextDataBtn3->Enabled = FileExists(TextBtnFile[2]);
	TextDataBtn4->Enabled = FileExists(TextBtnFile[3]);
	TextDataBtn5->Enabled = FileExists(TextBtnFile[4]);
	TextDataBtn6->Enabled = FileExists(TextBtnFile[5]);
	TextDataBtn7->Enabled = FileExists(TextBtnFile[6]);
	TextDataBtn8->Enabled = FileExists(TextBtnFile[7]);
	TextDataBar->Visible  = (bcnt>0);

	//OXg
	ExceptWordList->Clear();
	for (int i=1;;i++) {
		UnicodeString wd = IniFile->ReadString(sct, "ExceptWord"+IntToStr(i), EmptyStr);
		if (wd.IsEmpty()) break;
		ExceptWordList->Add(wd);
	}

	InitClipboardChain();

	Screen->Cursor = crDefault;
}

//---------------------------------------------------------------------------
__fastcall TClipBdList::TClipBdList(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormCreate(TObject *Sender)
{
	ClipLstFont = NULL;

	CbChained	 = false;
	ClipEnabled  = false;
	WmPasteClass = EmptyStr;

	ExceptWordList = new TStringList();

	RecyclePrc();

	load_ComboBoxItems(FindComboBox, IniFile, "FindHistory", MAX_FINDHISTORY);
}

//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormShow(TObject *Sender)
{
	//\t̂߂
	//炩ߌ݂̃tH[JX擾Ă
	hLastWnd	  = ::GetForegroundWindow();
	LastThreadID  = ::GetWindowThreadProcessId(hLastWnd, NULL);
	DWORD cur_tid = ::GetCurrentThreadId();
	if (::AttachThreadInput(cur_tid, LastThreadID, TRUE)) {
		hLastFocus = ::GetFocus();
		::AttachThreadInput(cur_tid, LastThreadID, FALSE);
	}
	else
		hLastFocus = NULL;

	UnicodeString sct = "ClipboardList";
	SetBounds(
		IniFile->ReadInteger(sct,"PosX",	0),
		IniFile->ReadInteger(sct,"PosY",	0),
		IniFile->ReadInteger(sct,"Width",	320),
		IniFile->ReadInteger(sct,"Height",	400));

	HistListBox->Font->Color = IniFile->ReadColor(sct, "FgColorL", clWindowText);
	HistListBox->Color		 = IniFile->ReadColor(sct, "BgColorL", clWindow);
	HistListBox->ItemHeight  = abs(HistListBox->Font->Height) + IniFile->ReadInteger(sct,"LineSpace", 0);

	PreviewMemo->Font->Color = IniFile->ReadColor(sct, "FgColorV", clWindowText);
	PreviewMemo->Color		 = IniFile->ReadColor(sct, "BgColorV", clWindow);
	PreviewMemo->Height		 = IniFile->ReadInteger(sct,"PreviewHeight", 50);

	TextListBox->Font->Color = IniFile->ReadColor(sct, "FgColorT", clWindowText);
	TextListBox->Color		 = IniFile->ReadColor(sct, "BgColorT", clWindow);
	TextListBox->ItemHeight  = abs(TextListBox->Font->Height) + IniFile->ReadInteger(sct,"LineSpace", 0);

	colCtrl = IniFile->ReadColor(sct, "CtrlColor", clGrayText);
	colLnCt = IniFile->ReadColor(sct, "LnCtColor", clWindowText);

	WmPasteClass = HotQMainForm->WmPasteClass;

	UpdateHistList();

	PageControl1Change(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormHide(TObject *Sender)
{
	UnicodeString sct = "ClipboardList";
	IniFile->WriteInteger(sct,"PosX",	Left);
	IniFile->WriteInteger(sct,"PosY",	Top);
	IniFile->WriteInteger(sct,"Width",	Width);
	IniFile->WriteInteger(sct,"Height",	Height);
	IniFile->WriteInteger(sct,"PreviewHeight",	PreviewMemo->Height);

	save_ComboBoxItems(FindComboBox, IniFile, "FindHistory", MAX_FINDHISTORY);

	IniFile->UpdateFile();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormDestroy(TObject *Sender)
{
	SaveHistList();

	if (CbChained) ::ChangeClipboardChain(Handle, hNextWnd);

	if (ClipLstFont) delete ClipLstFont;

	delete ClipHistList;
	delete ExceptWordList;
}

//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	switch (Key) {
	case VK_ESCAPE:	//B
		Hide(); break;
	}
}

//---------------------------------------------------------------------------
//Nbv{[h̏
//---------------------------------------------------------------------------
void __fastcall TClipBdList::InitClipboardChain()
{
	UnicodeString sct = "ClipboardList";
	if (IniFile->ReadBool(sct, "Enable")) {
		if (!CbChained) hNextWnd = ::SetClipboardViewer(Handle);
		CbChained = ClipEnabled = true;
	}
	else {
		if (CbChained) ::ChangeClipboardChain(Handle, hNextWnd);
		CbChained = ClipEnabled = false;
	}
}

//---------------------------------------------------------------------------
// WM_CHANGECBCHAIN ̏
//---------------------------------------------------------------------------
void __fastcall TClipBdList::WmChangeCbChain(TMessage &msg)
{
	if(hNextWnd == (HWND)(msg.WParam)) hNextWnd = (HWND)(msg.LParam);
	msg.Result = ::SendMessage(hNextWnd, msg.Msg, msg.WParam, msg.LParam);
}
//---------------------------------------------------------------------------
// WM_DRAWCLIPBOARD ̏
//---------------------------------------------------------------------------
void __fastcall TClipBdList::WmDrawClipboard(TMessage &msg)
{
	AddHistList();
	Sleep(50);
		/*
		  ̃AvRs[sۂɁA
		 uNbv{[hJƂł܂voꍇ̑΍cH
		*/

	msg.Result = ::SendMessage(hNextWnd, msg.Msg, msg.WParam, msg.LParam);
}


//---------------------------------------------------------------------------
//ڂ̃CfbNX擾
// idx w(-1)̏ꍇ́AI𒆂̍
//---------------------------------------------------------------------------
int __fastcall TClipBdList::GetHistListIndex(int idx)
{
	if (idx==-1) idx = HistListBox->ItemIndex;
	if (idx!=-1) {
		idx = StrToIntDef(get_tkn_r(HistListBox->Items->Strings[idx], "\x03"), -1);
		if (idx>=ClipHistList->Count) idx = -1;
	}
	return idx;
}
//---------------------------------------------------------------------------
//ڂ̕擾
// idx w(-1)̏ꍇ́AI𒆂̍
//---------------------------------------------------------------------------
UnicodeString __fastcall TClipBdList::GetListStr(int idx)
{
	UnicodeString retstr = EmptyStr;
	//
	if (PageControl1->ActivePage==ClipSheet) {
		idx = GetHistListIndex(idx);
		if (idx!=-1) retstr = ClipHistList->Items[idx]->Text;
	}
	//^
	else {
		if (TextListBox->Enabled) {
			if (idx==-1) idx = TextListBox->ItemIndex;
			if (idx!=-1) {
				retstr = TextListBox->Items->Strings[idx];
				if (retstr=="-")
					retstr = EmptyStr;
				else {
					if (retstr.Pos("\t")>0) retstr = Trim(get_tkn_r(retstr, "\t"));
					retstr = exp_FormatStr(retstr);
				}
			}
		}
	}
	return retstr;
}

//---------------------------------------------------------------------------
//݂̒^t@Cۑ
//---------------------------------------------------------------------------
bool __fastcall TClipBdList::SaveTextList()
{
	bool ret = false;
	Screen->Cursor = crHourGlass;
	try {
		TextListBox->Items->SaveToFile(TextDataFile);
		ret = true;
	} __finally {
		Screen->Cursor = crDefault;
	}
	return ret;
}

//---------------------------------------------------------------------------
//Xg: \XV
//---------------------------------------------------------------------------
void __fastcall TClipBdList::UpdateHistList(int idx)
{
	HistListBox->Clear();
	for (int i=0; i<ClipHistList->Count; i++)
		HistListBox->Items->Add(ClipHistList->Items[i]->ItemStr + "\x03" + IntToStr(i));

	if (idx>=HistListBox->Count) idx = HistListBox->Count-1;
	HistListBox->ItemIndex = idx;
}
//---------------------------------------------------------------------------
//Nbv{[h痚֒ǉ
//---------------------------------------------------------------------------
bool __fastcall TClipBdList::AddHistList()
{
	bool ret = true;
	try {
		if (!ClipEnabled) throw Exception(EmptyStr);
		if (!Clipboard()->HasFormat(CF_TEXT)) throw Exception(EmptyStr);
		UnicodeString cbuf = Clipboard()->AsText;

		if (MaxTextLen>0 && cbuf.Length()>MaxTextLen)    throw Exception(EmptyStr);
		if (MaxLineCnt>0 && count_lins(cbuf)>MaxLineCnt) throw Exception(EmptyStr);

		if (ClipHistList->Count>0) {
			if (CompareStr(ClipHistList->Items[0]->Text, cbuf)==0) throw Exception(EmptyStr);
		}

		//O
		for (int i=0; i<ExceptWordList->Count; i++) {
			UnicodeString wd = ExceptWordList->Strings[i];
			bool re_sw = false;
			if (wd.Length()>2) re_sw = (wd[1]=='/' && wd[wd.Length()]=='/');
			//K\
			if (re_sw) {
				wd.Delete(wd.Length(),1);
				wd.Delete(1,1);
				TRegExOptions opt;  opt<<roIgnoreCase;
				if (TRegEx::IsMatch(cbuf,wd, opt)) throw Exception(EmptyStr);
			}
			//ʏ핶
			else {
				if (pos_i(wd, cbuf)>0) throw Exception(EmptyStr);
			}
		}

		//^ɂ̂O
		for (int i=0; i<TextListBox->Count; i++) {
			UnicodeString tbuf = TextListBox->Items->Strings[i];
			if (tbuf=="-") continue;
			if (tbuf.Pos("\t")>0) tbuf = Trim(get_tkn_r(tbuf, "\t"));
			tbuf = exp_FormatStr(tbuf);
			if (CompareStr(Trim(tbuf), Trim(cbuf))==0) throw Exception(EmptyStr);
		}

		HistoryRec *hp = new HistoryRec(cbuf);
		ClipHistList->Insert(0, hp);

		//ȑȌdf[^폜
		int idx = 1;
		while (idx<ClipHistList->Count) {
			if (CompareStr(ClipHistList->Items[idx]->Text, cbuf)==0) {
				delete ClipHistList->Items[idx];
				ClipHistList->Delete(idx);
			}
			else
				idx++;
		}
		//ő區ڐŐ
		while (ClipHistList->Count>MaxCbItems) {
			delete ClipHistList->Items[MaxCbItems];
			ClipHistList->Delete(MaxCbItems);
		}
		UpdateHistList();
	}
	catch(...) {
		ret = false;
	}
	return ret;
}
//---------------------------------------------------------------------------
//Nbv{[ht@Cɕۑ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SaveHistList()
{
	if (SaveHistory) ClipHistList->SaveToFile(ClipDataFile);
}

//---------------------------------------------------------------------------
void __fastcall TClipBdList::PageControl1Change(TObject *Sender)
{
	if (PageControl1->ActivePage==ClipSheet) {
		HistListBox->SetFocus();
		HistListBoxClick(NULL);
	}
	else {
		if (TextListBox->Enabled) TextListBox->SetFocus();
		TextListBoxClick(NULL);
	}
}

//---------------------------------------------------------------------------
//Xg: ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TClipBdList::HistListBoxDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
	TListBox *lst = (TListBox *)Control;
	TCanvas *cv = lst->Canvas;
	cv->FillRect(Rect); //NA

	int fh = abs(cv->Font->Height);
	int yp = Rect.Top  + (lst->ItemHeight-fh)/2;
	int xp = Rect.Left + 4;

	//s\
	if (ShowLnCt) {
		int idx  = GetHistListIndex(Index);
		int lcnt = (idx!=-1)? ClipHistList->Items[idx]->LineCount : 1;
		TColor orgcol = cv->Font->Color;
		cv->Font->Color = colLnCt;
		UnicodeString lcnt_str = UnicodeString().sprintf(_T("%2u"), lcnt);
		cv->TextOut(xp, yp, lcnt_str);
		cv->Font->Color = orgcol;
		xp += (cv->TextWidth(lcnt_str) + 2);
		cv->Pen->Color = colLnCt;
		cv->Pen->Style = psSolid;
		cv->MoveTo(xp, Rect.Top);
		cv->LineTo(xp, Rect.Bottom);
		xp += 6;
	}

	//e\
	UnicodeString itmstr = get_tkn(lst->Items->Strings[Index], "\x03");
	for (;;) {
		int p0 = itmstr.Pos("\t");
		int p1 = itmstr.Pos("\n");
		int cp;
		if		(p0==0) cp = p1;
		else if (p1==0) cp = p0;
		else			cp = std::min(p0,p1);
		if (cp>0) {
			UnicodeString tmpstr = itmstr.SubString(1,cp-1);
			itmstr.Delete(1,cp);
			cv->TextOut(xp, yp, tmpstr);	xp += cv->TextWidth(tmpstr);
			TColor orgcol = cv->Font->Color;
			cv->Font->Color = colCtrl;
			if ((cv->Font->Name.Pos("lr ")==1) || (cv->Font->Name.Pos("MS ")==1))
				tmpstr = (cp==p0)? _T("\u21c0") : _T("\u21b4");
			else
				tmpstr = (cp==p0)? "" : "";
			cv->TextOut(xp, yp, tmpstr);	xp += (cv->TextWidth(tmpstr)+4);
			cv->Font->Color = orgcol;
			if (itmstr.IsEmpty()) break;
			if (xp > Rect.Right) break;
		}
		else {
			cv->TextOut(xp, yp, itmstr);
			break;
		}
	}
}

//---------------------------------------------------------------------------
//Xg: L[
//---------------------------------------------------------------------------
void __fastcall TClipBdList::HistListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	TListBox *lp = dynamic_cast<TListBox *>(Sender);	if (lp==NULL) return;

	switch (Key) {
	case VK_RETURN:  PasteAction->Execute();   break;
	case VK_DELETE:  DelItemAction->Execute(); break;
	case VK_ESCAPE:  Hide(); break;

	case VK_UP:
		if (lp->ItemIndex==0) {
			lp->ItemIndex = lp->Count-1;
			Key = 0;
		}
		break;
	case VK_DOWN:
		if (lp->ItemIndex==lp->Count-1) {
			lp->ItemIndex = 0;
			Key = 0;
		}
		break;
	}
}
//---------------------------------------------------------------------------
//Xg: }EX
//---------------------------------------------------------------------------
void __fastcall TClipBdList::HistListBoxClick(TObject *Sender)
{
	TListBox *lp = HistListBox;
	int idx = GetHistListIndex();
	if (idx!=-1) {
		UnicodeString tmpstr = UnicodeString().sprintf(_T("%3u/%3u"), lp->ItemIndex+1, lp->Count);
		if (lp->Count != ClipHistList->Count) tmpstr.cat_sprintf(_T("(%u)"), ClipHistList->Count);
		StatusBar1->Panels->Items[0]->Text = tmpstr;
		HistoryRec *hp = ClipHistList->Items[idx];
		StatusBar1->Panels->Items[1]->Text
			= UnicodeString().sprintf(_T("%8u/ %5us"), hp->Text.Length(), hp->LineCount);
		if (PreviewLn>0 && hp->LineCount>=PreviewLn) {
			PreviewMemo->Lines->Text = hp->Text;
			PreviewMemo->Visible = true;
			Splitter1->Align	 = alTop;
			PreviewMemo->Align	 = alBottom;
			Splitter1->Align	 = alBottom;
		}
		else
			PreviewMemo->Visible = false;
	}
	else {
		StatusBar1->Panels->Items[0]->Text
			= UnicodeString().sprintf(_T("-/%u(%u)"), lp->Count, ClipHistList->Count);
		StatusBar1->Panels->Items[1]->Text = EmptyStr;
	}
}

//---------------------------------------------------------------------------
//\t
//---------------------------------------------------------------------------
void __fastcall TClipBdList::PasteActionExecute(TObject *Sender)
{
	do {
		UnicodeString tmpstr = GetListStr();
		if (tmpstr.IsEmpty()) break;

		//\t
		Clipboard()->AsText = tmpstr;
		DWORD cur_tid = ::GetCurrentThreadId();
		if (::AttachThreadInput(cur_tid, LastThreadID, TRUE)) {
			::SetForegroundWindow(hLastWnd);
			::SetFocus(hLastFocus);
			UnicodeString c_nam = get_ClassName(hLastFocus);
			TStringDynArray c_lst = SplitString(WmPasteClass, ";");
			bool wm_flag = false;
			for (int j=0; j<c_lst.Length && !wm_flag; j++) wm_flag = SameText(c_nam, c_lst[j]);
			//WM_PASTE œ\t
			if (wm_flag)
				::SendMessage(hLastFocus, WM_PASTE, 0, 0);
			//Ctrl + V œ\t
			else {
				Sleep(50);
				::keybd_event(VK_CONTROL, 0, 0, 0);
				::keybd_event('V', 0, 0, 0);
				Sleep(100);
				::keybd_event('V', 0, KEYEVENTF_KEYUP, 0);
				::keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
				Application->ProcessMessages();
			}
			::AttachThreadInput(cur_tid, LastThreadID, FALSE);
		}
	} while (0);

	Hide();
}

//---------------------------------------------------------------------------
//Nbv{[hɓ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::CopyClipActionExecute(TObject *Sender)
{
	Clipboard()->AsText = GetListStr();
	Hide();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SelItemUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);	if (ap==NULL) return;
	if (PageControl1->ActivePage==ClipSheet)
		ap->Enabled = !GetListStr().IsEmpty();
	else {
		ap->Enabled = !GetListStr().IsEmpty() && !ItemEditPanel->Visible;
	}
}

//---------------------------------------------------------------------------
//^ɒǉo^
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegToTextActionExecute(TObject *Sender)
{
	RegTextList(GetListStr());
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegToTextActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);	if (ap==NULL) return;
	ap->Enabled = !GetListStr().IsEmpty();
}

//---------------------------------------------------------------------------
//Xg: sɓWJ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ExLineActionExecute(TObject *Sender)
{
	int idx = GetHistListIndex();	if (idx==-1) return;
	UnicodeString sbuf = ClipHistList->Items[idx]->Text;
	TDateTime  tm = ClipHistList->Items[idx]->CreTime;
	delete ClipHistList->Items[idx];
	ClipHistList->Delete(idx);
	sbuf = ReplaceStr(sbuf,"\r\n", "\n");
	sbuf = ReplaceStr(sbuf,"\r", "\n");
	int ixp = idx;
	while (!sbuf.IsEmpty() && ixp<MaxCbItems) {
		int p = sbuf.Pos("\n");
		if (p==0) {
			if (!sbuf.IsEmpty()) {
				HistoryRec *hp = new HistoryRec(sbuf);
				hp->CreTime = tm;
				ClipHistList->Insert(ixp++, hp);
			}
			sbuf = EmptyStr;
		}
		else {
			UnicodeString tmpstr = sbuf.SubString(1,p-1);
			if (!tmpstr.IsEmpty()) {
				HistoryRec *hp = new HistoryRec(tmpstr);
				hp->CreTime = tm;
				ClipHistList->Insert(ixp++, hp);
			}
			sbuf.Delete(1,p);
		}
		tm -= 0.0000001157;	// тȂ悤 -1/100sec
	}

	while (ClipHistList->Count>MaxCbItems) {
		delete ClipHistList->Items[MaxCbItems];
		ClipHistList->Delete(MaxCbItems);
	}
	UpdateHistList(idx);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ExLineActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);	if (ap==NULL) return;
	int idx = HistListBox->ItemIndex;
	if (idx!=-1)
		ap->Enabled = (ClipHistList->Items[idx]->LineCount>1);
	else
		ap->Enabled = false;
}

//---------------------------------------------------------------------------
//ڂ폜
//---------------------------------------------------------------------------
void __fastcall TClipBdList::DelItemActionExecute(TObject *Sender)
{
	if (PageControl1->ActivePage==ClipSheet) {
		TListBox *lp = HistListBox;
		if (lp->ItemIndex==-1) return;
		int idx = GetHistListIndex();	if (idx==-1) return;

		delete ClipHistList->Items[idx];
		ClipHistList->Delete(idx);

		int itm_idx = lp->ItemIndex;
		lp->Items->Delete(itm_idx);

		for (int i=itm_idx; i<lp->Count; i++) {
			int n = StrToIntDef(get_tkn_r(lp->Items->Strings[i], "\x03"), -1);
			if (n>idx) {
				UnicodeString itmstr = get_tkn(lp->Items->Strings[i], "\x03");
				n--;
				lp->Items->Strings[i] = itmstr + "\x03" + IntToStr(n);
			}
		}

		if (itm_idx>=lp->Count) itm_idx = lp->Count-1;
		lp->ItemIndex = itm_idx;
		HistListBoxClick(NULL);
	}
	else {
		TListBox *lp = TextListBox;
		int idx = lp->ItemIndex;
		if (idx!=-1) lp->Items->Delete(idx);
		if (idx>=lp->Count) idx = lp->Count-1;
		lp->ItemIndex = idx;
		TextListBoxClick(NULL);
		SaveTextList();
	}
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::DelItemActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);	if (ap==NULL) return;
	if (PageControl1->ActivePage==ClipSheet)
		ap->Enabled = !GetListStr().IsEmpty();
	else
		ap->Enabled = (TextListBox->ItemIndex!=-1 && !ItemEditPanel->Visible);
}

//---------------------------------------------------------------------------
//Xg̑Sڂ폜
//---------------------------------------------------------------------------
void __fastcall TClipBdList::AllDelActionExecute(TObject *Sender)
{
	//S
	if (HistListBox->Count == ClipHistList->Count) {
		for (int i=0; i<ClipHistList->Count; i++) delete ClipHistList->Items[i];
		ClipHistList->Clear();
		HistListBox->Clear();
	}
	//i荞ݒ
	else {
		for (int i=0; i<HistListBox->Count; i++) {
			int idx = StrToIntDef(get_tkn_r(HistListBox->Items->Strings[i], "\x03"), -1);
			idx -= i;
			if (idx>=0 && idx<ClipHistList->Count) {
				delete ClipHistList->Items[idx];
				ClipHistList->Delete(idx);
			}
		}
	}
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::AllDelActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);	if (ap==NULL) return;
	ap->Enabled = (HistListBox->Count>0);
}

//---------------------------------------------------------------------------
//Xg: \[g
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortTextActionExecute(TObject *Sender)
{
	ClipHistList->Sort(HistCmp_Text);
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortTimeActionExecute(TObject *Sender)
{
	ClipHistList->Sort(HistCmp_Time);
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortLengthActionExecute(TObject *Sender)
{
	ClipHistList->Sort(HistCmp_Length);
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortLineCntActionExecute(TObject *Sender)
{
	ClipHistList->Sort(HistCmp_LineCnt);
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);	if (ap==NULL) return;
	ap->Enabled = (ClipHistList->Count>1);
}

//---------------------------------------------------------------------------
//ꗗ璊o
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ListExtractActionExecute(TObject *Sender)
{
	UnicodeString swd = FindComboBox->Text;
	add_ComboBox_history(FindComboBox, swd);		//ɒǉ

	//o
	int idx = 0;
	while (idx<HistListBox->Count) {
		UnicodeString lbuf = HistListBox->Items->Strings[idx];
		if (find_mlt(swd, lbuf, true, true))	//܂܂Ȃ
			HistListBox->Items->Delete(idx);
		else
			idx++;
	}

	if (HistListBox->Count>0) HistListBox->ItemIndex = 0;
	HistListBoxClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ListExtractActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction*>(Sender);	if (ap==NULL) return;
	ap->Enabled = (!FindComboBox->Text.IsEmpty() && HistListBox->Count>0);
}

//---------------------------------------------------------------------------
//ꗗ珜O
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ListExceptActionExecute(TObject *Sender)
{
	UnicodeString swd = FindComboBox->Text;

	//ɒǉ
	TStrings *lp = FindComboBox->Items;
	int idx = lp->IndexOf(swd);
	if (idx!=0) {
		if (idx>0) lp->Delete(idx);
		lp->Insert(0, swd);
	}
	FindComboBox->Text = swd;

	//O
	idx = 0;
	while (idx<HistListBox->Count) {
		UnicodeString lbuf = HistListBox->Items->Strings[idx];
		if (find_mlt(swd, lbuf))
			HistListBox->Items->Delete(idx);
		else
			idx++;
	}

	if (HistListBox->Count>0) HistListBox->ItemIndex = 0;
	HistListBoxClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ListExceptActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction*>(Sender);	if (ap==NULL) return;
	ap->Enabled = (!FindComboBox->Text.IsEmpty() && HistListBox->Count>0);
}

//---------------------------------------------------------------------------
//i荞݂
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ListReleaseActionExecute(TObject *Sender)
{
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ListReleaseActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction*>(Sender);	if (ap==NULL) return;
	ap->Enabled = (HistListBox->Count != ClipHistList->Count);
}

//---------------------------------------------------------------------------
//R{{bNXł̃L[
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FindComboBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	switch (Key) {
	case VK_RETURN: ListExtractAction->Execute(); break;
	case VK_ESCAPE:	Hide(); break;
	}

}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FindComboBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	switch (Key) {
	case VK_ESCAPE: case VK_RETURN:
		Key = 0;
		break;
	}
}

//---------------------------------------------------------------------------
//ƂȂ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::StopActionExecute(TObject *Sender)
{
	ClipEnabled = !ClipEnabled;
	UnicodeString tmpstr = "Nbv{[h";
	if (!ClipEnabled) tmpstr += "  (~)";
	Caption = tmpstr;
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::StopActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);	if (ap==NULL) return;
	ap->Checked = !ClipEnabled;
}

//---------------------------------------------------------------------------
//ɖOtĂɕۑ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SaveHistActionExecute(TObject *Sender)
{
	SaveDialog1->Title		= "ɖOtĕۑ";
	SaveDialog1->Filter 	= "f[^t@C (*.txt)|*.TXT";
	SaveDialog1->DefaultExt = "TXT";
	SaveDialog1->FileName	= "*.txt";
	SaveDialog1->InitialDir	= ExtractFileDir(ClipDataFile);
	if (SaveDialog1->Execute()) {
		ClipHistList->SaveToFile(SaveDialog1->FileName);
	}
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SaveHistActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);	if (ap==NULL) return;
	ap->Enabled = (ClipHistList->Count>0);
}
//---------------------------------------------------------------------------
//t@CǍ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::LoadHistActionExecute(TObject *Sender)
{
	OpenDialog1->Title		= "t@CǍ";
	OpenDialog1->Filter 	= "f[^t@C (*.txt)|*.TXT";
	OpenDialog1->DefaultExt = "TXT";
	OpenDialog1->FileName	= "*.txt";
	OpenDialog1->InitialDir	= ExtractFileDir(ClipDataFile);
	if (OpenDialog1->Execute()) {
		ClipHistList->LoadFromFile(OpenDialog1->FileName);
		UpdateHistList();
	}
}

//---------------------------------------------------------------------------
//^Xg: ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State)
{
	TListBox *lst = (TListBox *)Control;
	TCanvas *cv = lst->Canvas;
	cv->FillRect(Rect); //NA

	UnicodeString itmstr = get_tkn(lst->Items->Strings[Index], "\t");
	int fh = abs(cv->Font->Height);
	int yp = Rect.Top + (lst->ItemHeight-fh)/2;
	int xp = Rect.Left + 4;
	if (itmstr=="-") {
		TRect rc = Rect; rc.Top += fh/2;
        ::DrawEdge(cv->Handle, &rc, EDGE_ETCHED, BF_TOP);
	}
	else {
		for (;;) {
			int p0 = itmstr.Pos("\\t");
			int p1 = itmstr.Pos("\\n");
			int cp;
			if		(p0==0) cp = p1;
			else if (p1==0) cp = p0;
			else			cp = std::min(p0,p1);
			if (cp>0) {
				UnicodeString tmpstr = itmstr.SubString(1,cp-1);
				itmstr.Delete(1,cp+1);
				cv->TextOut(xp, yp, tmpstr);	xp += cv->TextWidth(tmpstr);
				TColor orgcol = cv->Font->Color;
				cv->Font->Color = colCtrl;
				if ((cv->Font->Name.Pos("lr ")==1) || (cv->Font->Name.Pos("MS ")==1))
					tmpstr = (cp==p0)? _T("\u21c0") : _T("\u21b4");
				else
					tmpstr = (cp==p0)? "" : "";
				cv->TextOut(xp, yp, tmpstr);	xp += (cv->TextWidth(tmpstr)+4);
				cv->Font->Color = orgcol;
				if (itmstr.IsEmpty()) break;
				if (xp > Rect.Right) break;
			}
			else {
				cv->TextOut(xp, yp, itmstr);
				break;
			}
		}
	}
}

//---------------------------------------------------------------------------
//^Xg: hbO&hbvɂ鍀ڂ̈ړ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxStartDrag(TObject *Sender, TDragObject *&DragObject)
{
	PrevListIdx = -1;
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept)
{
	TListBox *lp = dynamic_cast<TListBox *>(Sender);	if (lp==NULL) return;
	Accept = (Source==Sender && lp->ItemIndex!=-1);		if (!Accept) return;

	int idx = lp->ItemAtPos(Point(X, Y), true);
	draw_ListItemLine(lp, PrevListIdx);		//Õhbv\
	draw_ListItemLine(lp, idx);				//Vhbv\`

	PrevListIdx = idx;
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxDragDrop(TObject *Sender, TObject *Source,
          int X, int Y)
{
	TListBox *lp = dynamic_cast<TListBox *>(Sender);	if (lp==NULL) return;
	int idx = lp->ItemAtPos(Point(X, Y), true);

	draw_ListItemLine(lp, PrevListIdx);		//Õhbv\

	if (idx!=-1) {
		lp->Items->Move(lp->ItemIndex, idx);
		SaveTextList();
	}
}

//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxClick(TObject *Sender)
{
	TListBox *lp = dynamic_cast<TListBox *>(Sender);	if (lp==NULL) return;
	StatusBar1->Panels->Items[0]->Text =
		(lp->ItemIndex!=-1)? UnicodeString().sprintf(_T("%3u/%3u"), lp->ItemIndex+1, lp->Count) : EmptyStr;

	UnicodeString itmstr = GetListStr();
	itmstr = ReplaceStr(itmstr,"\r\n", "\\n");
	itmstr = ReplaceStr(itmstr,"\t", "\\t");
	StatusBar1->Panels->Items[1]->Text = itmstr;
}
//---------------------------------------------------------------------------
//^Xg: L[
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	TListBox *lp = dynamic_cast<TListBox *>(Sender);	if (lp==NULL) return;

	switch (Key) {
	case VK_RETURN:  PasteAction->Execute();   break;
	case VK_DELETE:  DelItemAction->Execute(); break;
	case VK_ESCAPE:  Hide(); break;

	case VK_UP:
		if (lp->ItemIndex==0) {
			lp->ItemIndex = lp->Count-1;
			Key = 0;
		}
		break;
	case VK_DOWN:
		if (lp->ItemIndex==lp->Count-1) {
			lp->ItemIndex = 0;
			Key = 0;
		}
		break;
	}
}

//---------------------------------------------------------------------------
//^̒ǉo^
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegTextList(UnicodeString s, int idx)
{
	if (s.IsEmpty()) return;
	s = ReplaceStr(s,"\r\n", "\\n");
	s = ReplaceStr(s,"\r", "\\n");
	s = ReplaceStr(s,"\t", "\\t");
	if (TextListBox->Items->IndexOf(s)==-1) {
		if (idx>=0 && idx<TextListBox->Count)
			TextListBox->Items->Insert(idx, s);
		else
			TextListBox->Items->Add(s);
		SaveTextList();
	}
	else
		Application->MessageBox(_T("łɓo^Ă܂"), _T("x"), MB_OK|MB_ICONWARNING);
}

//---------------------------------------------------------------------------
//Nbv{[hǉo^
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegFromClipActionExecute(TObject *Sender)
{
	RegTextList(Clipboard()->AsText);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegFromClipActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);  if (ap==NULL) return;
	ap->Enabled = !Clipboard()->AsText.IsEmpty() && !ItemEditPanel->Visible;
}
//---------------------------------------------------------------------------
//Nbv{[h}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::InsFromClipActionExecute(TObject *Sender)
{
	RegTextList(Clipboard()->AsText, TextListBox->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::InsFromClipActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);  if (ap==NULL) return;
	ap->Enabled = (!Clipboard()->AsText.IsEmpty() && !ItemEditPanel->Visible && TextListBox->ItemIndex!=-1);
}
//---------------------------------------------------------------------------
//Zp[^}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::InsSepItemClick(TObject *Sender)
{
	int idx = TextListBox->ItemIndex;
	if (idx!=-1)
		TextListBox->Items->Insert(idx, "-");
	else
		TextListBox->Items->Add("-");
	SaveTextList();
}

//---------------------------------------------------------------------------
//^̒`t@CҏW
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditTextDataActionExecute(TObject *Sender)
{
	HotQMainForm->EditFile(TextDataFile);

	if (Application->MessageBox(
		_T("^̒`t@Cēǂݍ݂܂"), _T("mF"), MB_YESNO|MB_ICONQUESTION) == IDYES)
			ReloadTextDataAction->Execute();

	Hide();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditTextDataActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);  if (ap==NULL) return;
	ap->Enabled = !HotQMainForm->IniEditor.IsEmpty() && FileExists(TextDataFile) && !ItemEditPanel->Visible;
}
//---------------------------------------------------------------------------
//^̒`t@Cēǂݍ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ReloadTextDataActionExecute(TObject *Sender)
{
	TextListBox->Items->LoadFromFile(TextDataFile);
	if (TextListBox->Count>0) TextListBox->ItemIndex = 0;
	TextListBoxClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ReloadTextDataActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);  if (ap==NULL) return;
	ap->Enabled = FileExists(TextDataFile) && !ItemEditPanel->Visible;
}

//---------------------------------------------------------------------------
//^̍ڂҏW
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditTextItemActionExecute(TObject *Sender)
{
	int idx = TextListBox->ItemIndex;
	if (idx!=-1) {
		UnicodeString itmstr = TextListBox->Items->Strings[idx];
		if (itmstr.Pos("\t")>0) {
			ItemLabelEdit->Text = Trim(get_tkn(itmstr, "\t"));
			itmstr = get_tkn_r(itmstr, "\t");
		}
		else
			ItemLabelEdit->Text = EmptyStr;
		itmstr = ReplaceStr(itmstr,"\\n", "\r\n");
		itmstr = ReplaceStr(itmstr,"\\t", "\t");
		ItemMemo->Text = itmstr;

		ItemEditPanel->Visible = true;
		ItemMemo->SetFocus();
		TextDataBar->Enabled   = false;
		TextListBox->Enabled   = false;
	}
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditTextItemActionUpdate(TObject *Sender)
{
	TAction *ap = dynamic_cast<TAction *>(Sender);	if (ap==NULL) return;
	ap->Enabled = !GetListStr().IsEmpty() && !ItemEditPanel->Visible;
}

//---------------------------------------------------------------------------
//ҏWm
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditOkBtnClick(TObject *Sender)
{
	int idx = TextListBox->ItemIndex;
	if (idx!=-1) {
		UnicodeString itmstr = ItemMemo->Text;
		itmstr = ReplaceStr(itmstr,"\r\n", "\\n");
		itmstr = ReplaceStr(itmstr,"\t",   "\\t");
		if (!ItemLabelEdit->Text.IsEmpty())
			itmstr = ItemLabelEdit->Text + "\t" + itmstr;
		TextListBox->Items->Strings[idx] = itmstr;
		SaveTextList();
	}
	ItemEditPanel->Visible = false;
	TextDataBar->Enabled   = true;
	TextListBox->Enabled   = true;
	TextListBox->SetFocus();
}

//---------------------------------------------------------------------------
//ҏWf
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditCanBtnClick(TObject *Sender)
{
	ItemEditPanel->Visible = false;
	TextDataBar->Enabled   = true;
	TextListBox->Enabled   = true;
	TextListBox->SetFocus();
}
//---------------------------------------------------------------------------
//̎Q
//---------------------------------------------------------------------------
void __fastcall TClipBdList::Ref_ItemClick(TObject *Sender)
{
	TMenuItem *mp = dynamic_cast<TMenuItem *>(Sender);	if (mp==NULL) return;
	UnicodeString s = mp->Caption;
	Clipboard()->AsText = get_tkn(mp->Caption, " ");
	if (ItemLabelEdit->Focused())
		ItemLabelEdit->PasteFromClipboard();
	else if (ItemMemo->Focused())
		ItemMemo->PasteFromClipboard();
}

//---------------------------------------------------------------------------
//^t@CI{^
//---------------------------------------------------------------------------
bool __fastcall TClipBdList::ChangeTextData(int idx)
{
	bool ret = false;
	if (idx>=0 && idx<MAX_TEXTDATABTN) {
		if (FileExists(TextBtnFile[idx])) {
			TextDataFile = TextBtnFile[idx];
			TextListBox->Items->LoadFromFile(TextDataFile);
			if (TextListBox->Count>0) TextListBox->ItemIndex = 0;
			TextListBoxClick(NULL);
			IniFile->WriteString("ClipboardList", "TextDataFile",	TextDataFile);
			ret = true;
		}
	}
	return ret;
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextDataBtnClick(TObject *Sender)
{
	TComponent *cp = dynamic_cast<TComponent *>(Sender);	if (cp==NULL) return;
	ChangeTextData(cp->Tag);
}
//---------------------------------------------------------------------------

