//----------------------------------------------------------------------//
// zbgL[ꗗ														//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include "HKeyRec.h"
#include "UserFunc.h"
#include "UIniFile.h"
#include "Unit3.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THotKeyHelp *HotKeyHelp;

//---------------------------------------------------------------------------
__fastcall THotKeyHelp::THotKeyHelp(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormShow(TObject *Sender)
{
	UnicodeString sct = "HotKeyList";
	SetBounds(
		IniFile->ReadInteger(sct,"WinLeft",		(Screen->Width-Width)/2),
		IniFile->ReadInteger(sct,"WinTop",		(Screen->Height-Height)/2),
		IniFile->ReadInteger(sct,"WinWidth",	500),
		IniFile->ReadInteger(sct,"WinHeight",	400));

	HKeyListBox->TabWidth = (::GetDialogBaseUnits() & 0x0000ffff) * 10;
	HKeyListBox->Items->Clear();
	HKeyListBox->ItemHeight = abs(HKeyListBox->Font->Height) * 3 / 2;

	MaxKeystr = EmptyStr;
	for (int i=0; i<HKeyList->Count; i++) {
		HKeyRec *kp = (HKeyRec*)HKeyList->Items[i];
		if (kp->id>=ID_HOTQ_BASE+1 && kp->id<=ID_HOTQ_BASE+MAX_HOTKEY) {
			UnicodeString keystr = shortcut_to_text(kp->sc_inf);
			UnicodeString cntstr;
			if (!kp->command.IsEmpty())
				cntstr = "R}h: "+kp->command;
			else if (!kp->exe_file[0].IsEmpty()) {
				cntstr = kp->exe_file[0];
				UnicodeString ext = ExtractFileExt(cntstr);
				if (SameText(ext, ".EXE") || SameText(ext, ".COM") || SameText(ext, ".BAT"))
					cntstr = ExtractFileName(cntstr);
				if (!kp->exe_param[0].IsEmpty()) cntstr += (" "+kp->exe_param[0]);
			}
			else if (!kp->act_class[0].IsEmpty() || !kp->act_title[i].IsEmpty() ||
					 !kp->act_tit_r[i].IsEmpty() || !kp->act_tit_m[i].IsEmpty())
			{
				cntstr = "ANeBu: "+kp->act_class[0];
				if (!kp->act_title[i].IsEmpty()) cntstr += (","+kp->act_title[i]);
				if (!kp->act_tit_r[i].IsEmpty()) cntstr += (","+kp->act_tit_r[i]);
				if (!kp->act_tit_m[i].IsEmpty()) cntstr += (","+kp->act_tit_m[i]);
			}
			else if (!kp->qx_macro.IsEmpty())	cntstr = kp->qx_macro;
			else if (!kp->sound.IsEmpty())		cntstr = kp->sound;
			else if (!kp->wall_paper.IsEmpty())	cntstr = kp->wall_paper;

			if (Canvas->TextWidth(keystr) > Canvas->TextWidth(MaxKeystr)) MaxKeystr = keystr;
			HKeyListBox->Items->Add(keystr + "\t" + cntstr);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	UnicodeString sct = "HotKeyList";
	IniFile->WriteInteger(sct,"WinLeft",	Left);
	IniFile->WriteInteger(sct,"WinTop",		Top);
	IniFile->WriteInteger(sct,"WinWidth",	Width);
	IniFile->WriteInteger(sct,"WinHeight",	Height);
	IniFile->UpdateFile();
}

//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormPaint(TObject *Sender)
{
	//TCYύXObv`
	RECT rc = Rect(
		ClientWidth - ::GetSystemMetrics(SM_CXHSCROLL),
		ClientHeight - ::GetSystemMetrics(SM_CYVSCROLL),
		ClientWidth, ClientHeight);
	::DrawFrameControl(Canvas->Handle, &rc, DFC_SCROLL,	DFCS_SCROLLSIZEGRIP);
}
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::FormResize(TObject *Sender)
{
	Repaint();
}

//---------------------------------------------------------------------------
//ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::HKeyListBoxDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = dynamic_cast<TListBox *>(Control);	if (lp==NULL) return;
	TCanvas  *cv = lp->Canvas;
	cv->Brush->Color = clWindow;
	cv->Font->Color  = clWindowText;
	cv->FillRect(Rect);
	int w_key = cv->TextWidth(MaxKeystr)+32;
	UnicodeString lbuf = lp->Items->Strings[Index];
	cv->TextOut(Rect.Left + 2,     Rect.Top+1,	get_tkn(lbuf, "\t"));
	cv->TextOut(Rect.Left + w_key, Rect.Top+1,	get_tkn_r(lbuf, "\t"));
}

//---------------------------------------------------------------------------
void __fastcall THotKeyHelp::CloseBtnClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

